package palmbible.output;

import java.io.*;
import java.util.*;

import palmbible.parser.*;
import palmbible.util.*;

public class PlainDoc extends GenericDoc
{
	protected Template verseTP;

	public PlainDoc(BibleDoc bibleDoc, String docName) throws Exception
	{
		super(bibleDoc, docName);

		setTemplatePackage("/template/plain/");
		verseTP = getTemplate("verse");

		generate();
	}

	protected void beginBible(Map wordMap) throws Exception
	{
		System.out.println("Making Plain Text File ...");

		setOutputDir(".");
		setOutputFile(wordMap.get("%%docname%%") + ".plain.txt");
	}

	protected void endBible(Map wordMap) throws Exception
	{
		System.out.println("Plain Text File Generated ...");
		System.out.println();
	}
	
	protected void verseText(Map wordMap) throws Exception
	{
		print(verseTP.getString(wordMap));
	}
}
