package palmbible.util;


public class CommandLine
{
	protected boolean pdbType = false;
	protected boolean pcType = false;
	protected boolean plainType = false;
	protected boolean htmlType = false;
	protected boolean rtfType = false;
	protected boolean thmlType = false;
	protected boolean monoonType = false;

	protected static final String PDB_TYPE = "pdb";
	protected static final String PC_TYPE = "pc";
	protected static final String PLAIN_TYPE = "plain";
	protected static final String HTML_TYPE = "html";
	protected static final String RTF_TYPE = "rtf";
	protected static final String THML_TYPE = "thml";
	protected static final String MONOON_TYPE = "monoon";

	protected static final String QUIET = "q";
	protected static final String DECODE = "decode";
	protected static final String ENCODE = "encode";

	protected String inputFile;
	protected boolean quite = false;
	protected String decode;
	protected String encode;

	public CommandLine(String args[]) throws Exception
	{
		for (int i=0; i< args.length; i++){
			if (args[i].startsWith("-")){
				i = parseArgument(args[i].substring(1), args, i);
			} else {
				inputFile = args[i];
			}
		}
		
		if (inputFile == null){
			throwNoInputFile();
		}
	}
	
	public String getInputFile()
	{
		return inputFile;
	}
	
	public String getEncoding()
	{
		return encode;
	}
	
	public String getDecoding()
	{
		return decode;
	}
	
	public boolean exportPdb()
	{
		return pdbType;
	}
	
	public boolean exportPC()
	{
		return pcType;
	}
	
	public boolean exportPlain()
	{
		return plainType;
	}
	
	public boolean exportHtml()
	{
		return htmlType;
	}
	
	public boolean exportRtf()
	{
		return rtfType;
	}
	
	public boolean exportThml()
	{
		return thmlType;
	}
	
	public boolean exportMoNoon()
	{
		return monoonType;
	}

	public boolean getQuite()
	{
		return quite;
	}
	
	private int parseArgument(String command, String args[], int i)
	{
		if (command.equals(QUIET)){
			quite = true;
		} else if (command.equals(PDB_TYPE)){
			pdbType = true;
		} else if (command.equals(PC_TYPE)){
			pcType = true;
		} else if (command.equals(PLAIN_TYPE)){
			plainType = true;
		} else if (command.equals(HTML_TYPE)){
			htmlType = true;
		} else if (command.equals(RTF_TYPE)){
			rtfType = true;
		} else if (command.equals(THML_TYPE)){
			thmlType = true;
		} else if (command.equals(MONOON_TYPE)){
			monoonType = true;
		} else if (command.equals(DECODE)){
			decode = args[i + 1];
			i++;
		} else if (command.equals(ENCODE)){
			encode = args[i + 1];
			i++;
		}
		
		return i;
	}

	protected void throwNoInputFile() throws Exception
	{
		throw new Exception("No Input File");
	}
}
