/*****************************************************************************

    Bible Converter for Bible Reader
    Copyright (C) 2001  Poetry H.C. Poon
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    
    You may contact Poetry H.C. Poon at poetry@hongkong.com

*****************************************************************************/

package palmbible.util;

import java.util.*;

public class TreeNode
{
	protected String enc;

	public String string;
	public int index;
	public TreeNode leftNode = null;
	public TreeNode rightNode = null;

	public TreeNode(String string, int index) throws Exception
	{
		this.string = string;
		this.index = index;
	}
	
	public TreeNode(String string, int index, String enc) throws Exception
	{
		this.string = new String(string.getBytes(enc), "iso-8859-1");
		this.index = index;
	}
	
	public void putNode(TreeNode rootNode)
	{
		if (compare(rootNode, this) > 0) {
			if (rootNode.leftNode != null){
				putNode(rootNode.leftNode);
			} else {
				rootNode.leftNode = this;
			}
		} else {
			if (rootNode.rightNode != null){
				putNode(rootNode.rightNode);
			} else {
				rootNode.rightNode = this;
			}
		}
	}

	public void fillSorted(Vector words, Map indexMap)
	{
		if (leftNode != null){
			leftNode.fillSorted(words, indexMap);
		}

		words.addElement(string);
		indexMap.put(new Integer(index), new Integer(words.size()));

		if (rightNode != null){
			rightNode.fillSorted(words, indexMap);
		}
	}

	protected int compare(TreeNode node1, TreeNode node2)
	{
		int length1 = node1.string.length();
		int length2 = node2.string.length();

		if (length1 < length2){
			return -1;
		} else if (length1 > length2) {
			return 1;
		} else {
			return node1.string.compareTo(node2.string);
		}
	}
}
