/*****************************************************************************

    Bible Reader for Palm
    Copyright (C) 2001  Ho Chuen Poon
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    
    You may contact Ho Chuen Poon at poetry@hongkong.com

*****************************************************************************/

// Constants

#define screenWidth 161

#define bookTextType 0xFFFF
#define chapTextType 0xFFFE
#define descTextType 0xFFFD
#define versTextType 0xFFFC

// Structure Definition

typedef struct WordIndexType {
	UInt16 wordLength;
	UInt16 totalWord;
	Boolean compressed;
	Boolean nothing;
} WordIndexType;
typedef WordIndexType *WordIndexPtr;

typedef struct WordInfoType {
	UInt16 totalIndexes;
	WordIndexType wordIndex[1];
} WordInfoType;
typedef WordInfoType *WordInfoPtr;

typedef struct DecoderType {
	UInt16 version;
	UInt16 recordIndex;
	UInt16 totalRecord;

	WordInfoPtr wordInfo;
	FullReaderType wordReader;

	char sepChar;
	Boolean byteShifted;
} DecoderType;
typedef DecoderType *DecoderPtr;

// Public Functions

void DecOpenDecoder(DecoderPtr decoder, UInt16 version);
void DecCloseDecoder(DecoderPtr decoder);
void DecDecodeVerse(DecoderPtr decoder, VersePtr verse, 
	FullReaderPtr recordReader, UInt32 verseStart, 
	UInt16 verseLength);
void DecDecodeVerseAsString(DecoderPtr decoder, char* verse, 
	FullReaderPtr recordReader, UInt32 verseStart, 
	UInt16 verseLength);

