/*****************************************************************************

    Bible Reader for Palm
    Copyright (C) 2001  Ho Chuen Poon
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    
    You may contact Ho Chuen Poon at poetry@hongkong.com

*****************************************************************************/

#define recordSize 4096

typedef struct FullReaderType {
	UInt16 version;

	UInt16 minRecord;
	UInt16 maxRecord;

	UInt16 recordIndex;
	UInt16 charIndex;

	UInt8* recordPtr;
} FullReaderType;
typedef FullReaderType *FullReaderPtr;

// Public Functions

void FrdOpenReader(FullReaderPtr recordReader, UInt16 version, 
	UInt16 minRecord, UInt16 maxRecord);
void FrdCloseReader(FullReaderPtr recordReader);
void FrdReadBegin(FullReaderPtr recordReader, UInt32 start);
void FrdReadEnd(FullReaderPtr recordReader);
UInt8 FrdReadChar(FullReaderPtr recordReader);

